SparkFun Electronics KiCad Libraries
====================================

This repository contains a set of KiCad libraries that match the SparkFun-Eagle-Libraries repository, as well as tools that can be used to manipulate various aspects of KiCad libraries and footprints.

**SparkFun DFM specifics**

The 'standard' libraries contain internal part numbers for ease of design. Some tools also exist, like the BOM generator, which are only useful with the internal part numbers.

*Note: By setting the field layer to white, the numbers become invisible*

Contents
-------------------

* [/Documentation](https://github.com/sparkfun/SparkFun-KiCad-Libraries/tree/master/Documentation) -- Contains documentation written during creation of this repository, with readme.md index of its own!
* [/Footprints](https://github.com/sparkfun/SparkFun-KiCad-Libraries/tree/master/Footprints) -- Standard SparkFun KiCad footprints, generated from our Eagle libraries
* [/Libraries](https://github.com/sparkfun/SparkFun-KiCad-Libraries/tree/master/Libraries) -- Standard SparkFun KiCad libraries, generated from our Eagle libraries
* [/SparkX](https://github.com/sparkfun/SparkFun-KiCad-Libraries/tree/master/SparkX) -- Libraries generated by SparkX
* [/Tools](https://github.com/sparkfun/SparkFun-KiCad-Libraries/tree/master/Tools) -- Tools for converting this and that


Versions
-------------------
*(Not all tags shown)*

* [V0.2](https://github.com/sparkfun/SparkFun-KiCad-Libraries/tree/V_0.2) - Unfilled footprints (for graphics) now converted by script.  All parts re-exported applying XXX-00000 if they don't have a product ID.
* [V0.5](https://github.com/sparkfun/SparkFun-KiCad-Libraries/tree/V_0.5) - Ready to start testing on boards

License
-------------------

This library is released under the [Creative Commons Attribution 4.0 International](https://creativecommons.org/licenses/by/4.0/) license. 
**You are welcome to use this library for commercial purposes.**
For attribution, we ask that when you begin to sell your device using our footprint, you email us with a link to the product being sold. 
We want bragging rights that we helped (in a very small part) to create your 8th world wonder. 
We would like the opportunity to feature your device on our homepage.

Please consider contributing back to this library or others to help the open-source hardware community continue to thrive and grow! 
